/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the CommunicationChannel type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CommunicationChannel{}

// CommunicationChannel struct for CommunicationChannel
type CommunicationChannel struct {
	Id string `json:"id"`
	OrganizationId string `json:"organization_id"`
	ContactId *string `json:"contact_id,omitempty"`
	Type string `json:"type"`
	Name string `json:"name"`
	ProfilePhoto *string `json:"profile_photo,omitempty"`
	MessengerId string `json:"messenger_id"`
	MessengerType Messenger `json:"messenger_type"`
	Permission *ComChannelPermission `json:"permission,omitempty"`
	CreatedAt string `json:"created_at"`
	UpdatedAt string `json:"updated_at"`
	Conversations []Conversation `json:"conversations,omitempty"`
}

// NewCommunicationChannel instantiates a new CommunicationChannel object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCommunicationChannel(id string, organizationId string, type_ string, name string, messengerId string, messengerType Messenger, createdAt string, updatedAt string) *CommunicationChannel {
	this := CommunicationChannel{}
	this.Id = id
	this.OrganizationId = organizationId
	this.Type = type_
	this.Name = name
	this.MessengerId = messengerId
	this.MessengerType = messengerType
	this.CreatedAt = createdAt
	this.UpdatedAt = updatedAt
	return &this
}

// NewCommunicationChannelWithDefaults instantiates a new CommunicationChannel object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCommunicationChannelWithDefaults() *CommunicationChannel {
	this := CommunicationChannel{}
	return &this
}

// GetId returns the Id field value
func (o *CommunicationChannel) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *CommunicationChannel) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *CommunicationChannel) SetId(v string) {
	o.Id = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *CommunicationChannel) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *CommunicationChannel) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *CommunicationChannel) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetContactId returns the ContactId field value if set, zero value otherwise.
func (o *CommunicationChannel) GetContactId() string {
	if o == nil || IsNil(o.ContactId) {
		var ret string
		return ret
	}
	return *o.ContactId
}

// GetContactIdOk returns a tuple with the ContactId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CommunicationChannel) GetContactIdOk() (*string, bool) {
	if o == nil || IsNil(o.ContactId) {
		return nil, false
	}
	return o.ContactId, true
}

// HasContactId returns a boolean if a field has been set.
func (o *CommunicationChannel) HasContactId() bool {
	if o != nil && !IsNil(o.ContactId) {
		return true
	}

	return false
}

// SetContactId gets a reference to the given string and assigns it to the ContactId field.
func (o *CommunicationChannel) SetContactId(v string) {
	o.ContactId = &v
}

// GetType returns the Type field value
func (o *CommunicationChannel) GetType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *CommunicationChannel) GetTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *CommunicationChannel) SetType(v string) {
	o.Type = v
}

// GetName returns the Name field value
func (o *CommunicationChannel) GetName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Name
}

// GetNameOk returns a tuple with the Name field value
// and a boolean to check if the value has been set.
func (o *CommunicationChannel) GetNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Name, true
}

// SetName sets field value
func (o *CommunicationChannel) SetName(v string) {
	o.Name = v
}

// GetProfilePhoto returns the ProfilePhoto field value if set, zero value otherwise.
func (o *CommunicationChannel) GetProfilePhoto() string {
	if o == nil || IsNil(o.ProfilePhoto) {
		var ret string
		return ret
	}
	return *o.ProfilePhoto
}

// GetProfilePhotoOk returns a tuple with the ProfilePhoto field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CommunicationChannel) GetProfilePhotoOk() (*string, bool) {
	if o == nil || IsNil(o.ProfilePhoto) {
		return nil, false
	}
	return o.ProfilePhoto, true
}

// HasProfilePhoto returns a boolean if a field has been set.
func (o *CommunicationChannel) HasProfilePhoto() bool {
	if o != nil && !IsNil(o.ProfilePhoto) {
		return true
	}

	return false
}

// SetProfilePhoto gets a reference to the given string and assigns it to the ProfilePhoto field.
func (o *CommunicationChannel) SetProfilePhoto(v string) {
	o.ProfilePhoto = &v
}

// GetMessengerId returns the MessengerId field value
func (o *CommunicationChannel) GetMessengerId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.MessengerId
}

// GetMessengerIdOk returns a tuple with the MessengerId field value
// and a boolean to check if the value has been set.
func (o *CommunicationChannel) GetMessengerIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.MessengerId, true
}

// SetMessengerId sets field value
func (o *CommunicationChannel) SetMessengerId(v string) {
	o.MessengerId = v
}

// GetMessengerType returns the MessengerType field value
func (o *CommunicationChannel) GetMessengerType() Messenger {
	if o == nil {
		var ret Messenger
		return ret
	}

	return o.MessengerType
}

// GetMessengerTypeOk returns a tuple with the MessengerType field value
// and a boolean to check if the value has been set.
func (o *CommunicationChannel) GetMessengerTypeOk() (*Messenger, bool) {
	if o == nil {
		return nil, false
	}
	return &o.MessengerType, true
}

// SetMessengerType sets field value
func (o *CommunicationChannel) SetMessengerType(v Messenger) {
	o.MessengerType = v
}

// GetPermission returns the Permission field value if set, zero value otherwise.
func (o *CommunicationChannel) GetPermission() ComChannelPermission {
	if o == nil || IsNil(o.Permission) {
		var ret ComChannelPermission
		return ret
	}
	return *o.Permission
}

// GetPermissionOk returns a tuple with the Permission field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CommunicationChannel) GetPermissionOk() (*ComChannelPermission, bool) {
	if o == nil || IsNil(o.Permission) {
		return nil, false
	}
	return o.Permission, true
}

// HasPermission returns a boolean if a field has been set.
func (o *CommunicationChannel) HasPermission() bool {
	if o != nil && !IsNil(o.Permission) {
		return true
	}

	return false
}

// SetPermission gets a reference to the given ComChannelPermission and assigns it to the Permission field.
func (o *CommunicationChannel) SetPermission(v ComChannelPermission) {
	o.Permission = &v
}

// GetCreatedAt returns the CreatedAt field value
func (o *CommunicationChannel) GetCreatedAt() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *CommunicationChannel) GetCreatedAtOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *CommunicationChannel) SetCreatedAt(v string) {
	o.CreatedAt = v
}

// GetUpdatedAt returns the UpdatedAt field value
func (o *CommunicationChannel) GetUpdatedAt() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value
// and a boolean to check if the value has been set.
func (o *CommunicationChannel) GetUpdatedAtOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedAt, true
}

// SetUpdatedAt sets field value
func (o *CommunicationChannel) SetUpdatedAt(v string) {
	o.UpdatedAt = v
}

// GetConversations returns the Conversations field value if set, zero value otherwise.
func (o *CommunicationChannel) GetConversations() []Conversation {
	if o == nil || IsNil(o.Conversations) {
		var ret []Conversation
		return ret
	}
	return o.Conversations
}

// GetConversationsOk returns a tuple with the Conversations field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CommunicationChannel) GetConversationsOk() ([]Conversation, bool) {
	if o == nil || IsNil(o.Conversations) {
		return nil, false
	}
	return o.Conversations, true
}

// HasConversations returns a boolean if a field has been set.
func (o *CommunicationChannel) HasConversations() bool {
	if o != nil && !IsNil(o.Conversations) {
		return true
	}

	return false
}

// SetConversations gets a reference to the given []Conversation and assigns it to the Conversations field.
func (o *CommunicationChannel) SetConversations(v []Conversation) {
	o.Conversations = v
}

func (o CommunicationChannel) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CommunicationChannel) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["organization_id"] = o.OrganizationId
	if !IsNil(o.ContactId) {
		toSerialize["contact_id"] = o.ContactId
	}
	toSerialize["type"] = o.Type
	toSerialize["name"] = o.Name
	if !IsNil(o.ProfilePhoto) {
		toSerialize["profile_photo"] = o.ProfilePhoto
	}
	toSerialize["messenger_id"] = o.MessengerId
	toSerialize["messenger_type"] = o.MessengerType
	if !IsNil(o.Permission) {
		toSerialize["permission"] = o.Permission
	}
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["updated_at"] = o.UpdatedAt
	if !IsNil(o.Conversations) {
		toSerialize["conversations"] = o.Conversations
	}
	return toSerialize, nil
}

type NullableCommunicationChannel struct {
	value *CommunicationChannel
	isSet bool
}

func (v NullableCommunicationChannel) Get() *CommunicationChannel {
	return v.value
}

func (v *NullableCommunicationChannel) Set(val *CommunicationChannel) {
	v.value = val
	v.isSet = true
}

func (v NullableCommunicationChannel) IsSet() bool {
	return v.isSet
}

func (v *NullableCommunicationChannel) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCommunicationChannel(val *CommunicationChannel) *NullableCommunicationChannel {
	return &NullableCommunicationChannel{value: val, isSet: true}
}

func (v NullableCommunicationChannel) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCommunicationChannel) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


